/*******************************************************************************
* File Name: MyPin.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_MyPin_H) /* Pins MyPin_H */
#define CY_PINS_MyPin_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MyPin_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v2_0 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 MyPin__PORT == 15 && ((MyPin__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    MyPin_Write(uint8 value) ;
void    MyPin_SetDriveMode(uint8 mode) ;
uint8   MyPin_ReadDataReg(void) ;
uint8   MyPin_Read(void) ;
uint8   MyPin_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MyPin_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MyPin_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MyPin_DM_RES_UP          PIN_DM_RES_UP
#define MyPin_DM_RES_DWN         PIN_DM_RES_DWN
#define MyPin_DM_OD_LO           PIN_DM_OD_LO
#define MyPin_DM_OD_HI           PIN_DM_OD_HI
#define MyPin_DM_STRONG          PIN_DM_STRONG
#define MyPin_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MyPin_MASK               MyPin__MASK
#define MyPin_SHIFT              MyPin__SHIFT
#define MyPin_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MyPin_PS                     (* (reg8 *) MyPin__PS)
/* Data Register */
#define MyPin_DR                     (* (reg8 *) MyPin__DR)
/* Port Number */
#define MyPin_PRT_NUM                (* (reg8 *) MyPin__PRT) 
/* Connect to Analog Globals */                                                  
#define MyPin_AG                     (* (reg8 *) MyPin__AG)                       
/* Analog MUX bux enable */
#define MyPin_AMUX                   (* (reg8 *) MyPin__AMUX) 
/* Bidirectional Enable */                                                        
#define MyPin_BIE                    (* (reg8 *) MyPin__BIE)
/* Bit-mask for Aliased Register Access */
#define MyPin_BIT_MASK               (* (reg8 *) MyPin__BIT_MASK)
/* Bypass Enable */
#define MyPin_BYP                    (* (reg8 *) MyPin__BYP)
/* Port wide control signals */                                                   
#define MyPin_CTL                    (* (reg8 *) MyPin__CTL)
/* Drive Modes */
#define MyPin_DM0                    (* (reg8 *) MyPin__DM0) 
#define MyPin_DM1                    (* (reg8 *) MyPin__DM1)
#define MyPin_DM2                    (* (reg8 *) MyPin__DM2) 
/* Input Buffer Disable Override */
#define MyPin_INP_DIS                (* (reg8 *) MyPin__INP_DIS)
/* LCD Common or Segment Drive */
#define MyPin_LCD_COM_SEG            (* (reg8 *) MyPin__LCD_COM_SEG)
/* Enable Segment LCD */
#define MyPin_LCD_EN                 (* (reg8 *) MyPin__LCD_EN)
/* Slew Rate Control */
#define MyPin_SLW                    (* (reg8 *) MyPin__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MyPin_PRTDSI__CAPS_SEL       (* (reg8 *) MyPin__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MyPin_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MyPin__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MyPin_PRTDSI__OE_SEL0        (* (reg8 *) MyPin__PRTDSI__OE_SEL0) 
#define MyPin_PRTDSI__OE_SEL1        (* (reg8 *) MyPin__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MyPin_PRTDSI__OUT_SEL0       (* (reg8 *) MyPin__PRTDSI__OUT_SEL0) 
#define MyPin_PRTDSI__OUT_SEL1       (* (reg8 *) MyPin__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MyPin_PRTDSI__SYNC_OUT       (* (reg8 *) MyPin__PRTDSI__SYNC_OUT) 


#if defined(MyPin__INTSTAT)  /* Interrupt Registers */

    #define MyPin_INTSTAT                (* (reg8 *) MyPin__INTSTAT)
    #define MyPin_SNAP                   (* (reg8 *) MyPin__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_MyPin_H */


/* [] END OF FILE */
