/*******************************************************************************
* File Name: Status.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Status_H) /* Pins Status_H */
#define CY_PINS_Status_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Status_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v2_0 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Status__PORT == 15 && ((Status__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    Status_Write(uint8 value) ;
void    Status_SetDriveMode(uint8 mode) ;
uint8   Status_ReadDataReg(void) ;
uint8   Status_Read(void) ;
uint8   Status_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Status_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Status_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Status_DM_RES_UP          PIN_DM_RES_UP
#define Status_DM_RES_DWN         PIN_DM_RES_DWN
#define Status_DM_OD_LO           PIN_DM_OD_LO
#define Status_DM_OD_HI           PIN_DM_OD_HI
#define Status_DM_STRONG          PIN_DM_STRONG
#define Status_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Status_MASK               Status__MASK
#define Status_SHIFT              Status__SHIFT
#define Status_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Status_PS                     (* (reg8 *) Status__PS)
/* Data Register */
#define Status_DR                     (* (reg8 *) Status__DR)
/* Port Number */
#define Status_PRT_NUM                (* (reg8 *) Status__PRT) 
/* Connect to Analog Globals */                                                  
#define Status_AG                     (* (reg8 *) Status__AG)                       
/* Analog MUX bux enable */
#define Status_AMUX                   (* (reg8 *) Status__AMUX) 
/* Bidirectional Enable */                                                        
#define Status_BIE                    (* (reg8 *) Status__BIE)
/* Bit-mask for Aliased Register Access */
#define Status_BIT_MASK               (* (reg8 *) Status__BIT_MASK)
/* Bypass Enable */
#define Status_BYP                    (* (reg8 *) Status__BYP)
/* Port wide control signals */                                                   
#define Status_CTL                    (* (reg8 *) Status__CTL)
/* Drive Modes */
#define Status_DM0                    (* (reg8 *) Status__DM0) 
#define Status_DM1                    (* (reg8 *) Status__DM1)
#define Status_DM2                    (* (reg8 *) Status__DM2) 
/* Input Buffer Disable Override */
#define Status_INP_DIS                (* (reg8 *) Status__INP_DIS)
/* LCD Common or Segment Drive */
#define Status_LCD_COM_SEG            (* (reg8 *) Status__LCD_COM_SEG)
/* Enable Segment LCD */
#define Status_LCD_EN                 (* (reg8 *) Status__LCD_EN)
/* Slew Rate Control */
#define Status_SLW                    (* (reg8 *) Status__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Status_PRTDSI__CAPS_SEL       (* (reg8 *) Status__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Status_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Status__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Status_PRTDSI__OE_SEL0        (* (reg8 *) Status__PRTDSI__OE_SEL0) 
#define Status_PRTDSI__OE_SEL1        (* (reg8 *) Status__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Status_PRTDSI__OUT_SEL0       (* (reg8 *) Status__PRTDSI__OUT_SEL0) 
#define Status_PRTDSI__OUT_SEL1       (* (reg8 *) Status__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Status_PRTDSI__SYNC_OUT       (* (reg8 *) Status__PRTDSI__SYNC_OUT) 


#if defined(Status__INTSTAT)  /* Interrupt Registers */

    #define Status_INTSTAT                (* (reg8 *) Status__INTSTAT)
    #define Status_SNAP                   (* (reg8 *) Status__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Status_H */


/* [] END OF FILE */
