/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <stdio.h>
#include <math.h>

#if defined (__GNUC__)
    /* Add an explicit reference to the floating point printf library */
    /* to allow the usage of floating point conversion specifiers. */
    /* This is not linked in by default with the newlib-nano library. */
    asm (".global _printf_float");
#endif

extern int16 ADC_res[128];
extern uint8  i;
extern uint8 N_s;



int main()
{
    
    N_s = 128;
    const float pi = 3.1416;
    uint8 k =0;
    uint8 n =0;
    float Yreal[128];
    float Yimag[128];
    float tsint;
    float tcost;
    float Betrag[128];
    char8 result1STR[16u];
    
    for(n=0; n < N_s; n++)
    {
        Yreal[n] = 0;
        Yimag[n] = 0;
        Betrag[n] = 0;
    }
    
    float Termsin[128];
    float Termcos[128];
    
    float Termsint;
    float Termcost;
    
    char8 TermsinSTR[16u];
    char8 TermcosSTR[16u];
    
    
    CyGlobalIntEnable;
    LCD_Start();
    LCD_ClearDisplay();
    ADC_SAR_Start();
    ADC_SAR_StartConvert();
    
    UART_Start();
    
    /*
    ADC_SAR_IRQ_Start();
    this what schud be done in the ADC_SAR_IRQ, see ADC_SAR_IRQ.c
    => buffering N_s Samples
    
    CY_ISR(ADC_SAR_IRQ_Interrupt)
    {

    ADC_res[i] = ADC_SAR_GetResult16();
    i++;
    if(i==N_s)
        {
         ADC_SAR_IRQ_Stop();
        }
    }
    */
    
       
    ADC_SAR_IRQ_Start();
    
    for(;;)
    {
        
        
        
        if(i==N_s)// if buffering is done
        {
            i=0;
            // Transfer the Samples via UART
            for(n=0; n < N_s; n++)
            {
            sprintf((char *)result1STR,"%d\n",ADC_res[n]);
            UART_PutString(result1STR);
            }
         
        
        
        
        Status_DR |= Status_MASK; //Set MyPin
        
        // calculate DFT
        for(k=0; k < N_s; k++)
        {
            for(n=0; n < N_s; n++)
            {
                Termcost = cos((2*pi*n*k)/N_s);
                tcost = ADC_res[n]*Termcost;
                Yreal[k] = Yreal[k] + tcost;
                
                Termsint = sin((2*pi*n*k)/N_s);
                tsint = ADC_res[n]*Termsint;
                Yimag[k] = Yimag[k] + tsint;
            }
            Betrag[k] = Yreal[k]*Yreal[k] + Yimag[k]*Yimag[k];
            
        }
        Status_DR &= ~Status_MASK; //Clear

            // Transfer the DFT via UART
            for(n=0; n < N_s; n++)
            {
            sprintf((char *)result1STR,"%+f\n",Betrag[n]);
            LCD_PrintString(result1STR);
            UART_PutString(result1STR);
            CyDelay(100u);
            LCD_ClearDisplay(); 
            }
            
        
        }
    }
}

/* [] END OF FILE */
